# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      db.py
# Author:       shengjuan
# Datetime:     2024/3/18 18:54
# Description:
# 
# ---------------------------------------------------------------------------
import pymysql

from stu_requests.InterfaceAutoTest import log_decorator
from stu_requests.InterfaceAutoTest.common.read_ini import ReadIni


class DB:
    @log_decorator
    def __init__(self):
        """连接数据库，获取游标对象和连接对象"""
        read_ini = ReadIni()
        try:
            self.conn = pymysql.connect(
                host=read_ini.get_sql_msg("host"),
                port=int(read_ini.get_sql_msg("port")),
                user=read_ini.get_sql_msg("user"),
                password=read_ini.get_sql_msg("password"),
                database=read_ini.get_sql_msg("database"),
                charset="utf8"
            )
            self.cursor = self.conn.cursor()
        except:
            raise ConnectionError("连接信息错误")

    @log_decorator
    def close(self):
        self.cursor.close()
        self.conn.close()

    @log_decorator
    def delete(self,sql_sentence):
        """根据传入的SQL语句删除"""
        try:
            self.cursor.execute(sql_sentence)
        except:
            raise  ValueError("sql语句错误")
        else:
            return self.conn.commit()

    @log_decorator
    def select(self,sql_sentence):
        """根据传入的SQL语句查询"""
        try:
            self.cursor.execute(sql_sentence)
        except:
            raise ValueError("sql语句错误")
        else:
            select_result = self.cursor.fetchall()
            if select_result:
                return select_result[0][0]

if __name__ == '__main__':
    db = DB()
    sql_select = """seLECT ID_ FROM uc_demension WHERE `CODE_`="abc_123_xyz";"""
    sql_delete = """delete from uc_demension WHERE `CODE_`="abc_123_xyz";"""
    print(db.select(sql_select))
    print(db.delete(sql_delete))







