# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      test_bpm.py
# Author:       shengjuan
# Datetime:     2024/3/18 20:24
# Description:
# 
# ---------------------------------------------------------------------------
import pytest

from stu_requests.InterfaceAutoTest import log
from stu_requests.InterfaceAutoTest.common.read_excel import ReadExcel


class TestBPM:
    @pytest.mark.parametrize("url,method,mime,case_data,expect_data,sql_type,sql_data,update_key",ReadExcel(username="basic",table_name="登录-维度管理").get_data())
    def test_bpm(self,db_fix,req_fix,url,method,mime,case_data,expect_data,sql_type,sql_data,update_key):
        if sql_type == "delete":
            db_fix.delete(sql_data)
        elif sql_type == "select":
            select_result = db_fix.select(sql_data)
            case_data[update_key] = select_result
        elif sql_type == "select|delete" and sql_type == "delete|select":
            db_fix.delete(sql_data)
            select_result = db_fix.select(sql_data)
            case_data[update_key] = select_result

        res = req_fix.request_all(req_url=url,req_method=method,req_mime=mime,case_data=case_data)
        try:
            for key in expect_data.keys():
                assert expect_data[key] == res.json().get(key)
        except AssertionError:
            log.error(f"断言失败，请求的url为：{url},请求的方法为：{method}，请求的媒体类型为:{mime}, 请求的用例数据：{case_data}， 期望数据为：{expect_data}，服务器返回的数据为：{res.text}")
            raise AssertionError("断言失败")
        else:
            log.error(f"断言成功，请求的url为：{url},请求的方法为：{method}，请求的媒体类型为:{mime}, 请求的用例数据：{case_data}， 期望数据为：{expect_data}，服务器返回的数据为：{res.text}")



